sdn.yaml 6.9 KB

123456789101112131415161718192021222324252627282930313233343536373839404142434445464748495051525354555657585960616263646566676869707172737475767778798081828384858687888990919293949596979899100101102103104105106107108109110111112113114115116117118119120121122123124125126127128129130131132133134135136137138139140141142143144145146147148149150151152153154155156157158159160161162163164165166167168169170171172173174175176177178179180181182183184185186187188189190191192193194195196197198199200201202203
  1. kind: DaemonSet
  2. apiVersion: apps/v1
  3. metadata:
  4. name: sdn
  5. namespace: openshift-sdn
  6. annotations:
  7. kubernetes.io/description: |
  8. This daemon set launches the OpenShift networking components (kube-proxy, DNS, and openshift-sdn).
  9. It expects that OVS is running on the node.
  10. image.openshift.io/triggers: |
  11. [
  12. {"from":{"kind":"ImageStreamTag","name":"node:v3.11"},"fieldPath":"spec.template.spec.containers[?(@.name==\"sdn\")].image"}
  13. ]
  14. spec:
  15. selector:
  16. matchLabels:
  17. app: sdn
  18. updateStrategy:
  19. type: RollingUpdate
  20. template:
  21. metadata:
  22. labels:
  23. app: sdn
  24. component: network
  25. type: infra
  26. openshift.io/component: network
  27. annotations:
  28. scheduler.alpha.kubernetes.io/critical-pod: ''
  29. spec:
  30. # Requires fairly broad permissions - ability to read all services and network functions as well
  31. # as all pods.
  32. serviceAccountName: sdn
  33. hostNetwork: true
  34. hostPID: true
  35. containers:
  36. # The network container launches the openshift-sdn process, the kube-proxy, and the local DNS service.
  37. # It relies on an up to date node-config.yaml being present.
  38. - name: sdn
  39. image: " "
  40. command:
  41. - /bin/bash
  42. - -c
  43. - |
  44. #!/bin/bash
  45. set -euo pipefail
  46. # if another process is listening on the cni-server socket, wait until it exits
  47. trap 'kill $(jobs -p); exit 0' TERM
  48. retries=0
  49. while true; do
  50. if echo 'test' | socat - UNIX-CONNECT:/var/run/openshift-sdn/cni-server.sock >/dev/null; then
  51. echo "warning: Another process is currently listening on the CNI socket, waiting 15s ..." 2>&1
  52. sleep 15 & wait
  53. (( retries += 1 ))
  54. else
  55. break
  56. fi
  57. if [[ "${retries}" -gt 40 ]]; then
  58. echo "error: Another process is currently listening on the CNI socket, exiting" 2>&1
  59. exit 1
  60. fi
  61. done
  62. # if the node config doesn't exist yet, wait until it does
  63. retries=0
  64. while true; do
  65. if [[ ! -f /etc/origin/node/node-config.yaml ]]; then
  66. echo "warning: Cannot find existing node-config.yaml, waiting 15s ..." 2>&1
  67. sleep 15 & wait
  68. (( retries += 1 ))
  69. else
  70. break
  71. fi
  72. if [[ "${retries}" -gt 40 ]]; then
  73. echo "error: No existing node-config.yaml, exiting" 2>&1
  74. exit 1
  75. fi
  76. done
  77. # Take over network functions on the node
  78. rm -Rf /etc/cni/net.d/*
  79. rm -Rf /host/opt/cni/bin/*
  80. cp -Rf /opt/cni/bin/* /host/opt/cni/bin/
  81. if [[ -f /etc/sysconfig/origin-node ]]; then
  82. set -o allexport
  83. source /etc/sysconfig/origin-node
  84. fi
  85. # use either the bootstrapped node kubeconfig or the static configuration
  86. file=/etc/origin/node/node.kubeconfig
  87. if [[ ! -f "${file}" ]]; then
  88. # use the static node config if it exists
  89. # TODO: remove when static node configuration is no longer supported
  90. for f in /etc/origin/node/system*.kubeconfig; do
  91. echo "info: Using ${f} for node configuration" 1>&2
  92. file="${f}"
  93. break
  94. done
  95. fi
  96. # Use the same config as the node, but with the service account token
  97. oc config "--config=${file}" view --flatten > /tmp/kubeconfig
  98. oc config --config=/tmp/kubeconfig set-credentials sa "--token=$( cat /var/run/secrets/kubernetes.io/serviceaccount/token )"
  99. oc config --config=/tmp/kubeconfig set-context "$( oc config --config=/tmp/kubeconfig current-context )" --user=sa
  100. # Launch the network process
  101. exec openshift start network --config=/etc/origin/node/node-config.yaml --kubeconfig=/tmp/kubeconfig --loglevel=${DEBUG_LOGLEVEL:-2}
  102. securityContext:
  103. runAsUser: 0
  104. # Permission could be reduced by selecting an appropriate SELinux policy
  105. privileged: true
  106. volumeMounts:
  107. # Directory which contains the host configuration.
  108. - mountPath: /etc/origin/node/
  109. name: host-config
  110. readOnly: true
  111. - mountPath: /etc/sysconfig/origin-node
  112. name: host-sysconfig-node
  113. readOnly: true
  114. # Mount the entire run directory for socket access for Docker or CRI-o
  115. # TODO: remove
  116. - mountPath: /var/run
  117. name: host-var-run
  118. # Run directories where we need to be able to access sockets
  119. - mountPath: /var/run/dbus/
  120. name: host-var-run-dbus
  121. readOnly: true
  122. - mountPath: /var/run/openvswitch/
  123. name: host-var-run-ovs
  124. readOnly: true
  125. - mountPath: /var/run/kubernetes/
  126. name: host-var-run-kubernetes
  127. readOnly: true
  128. # We mount our socket here
  129. - mountPath: /var/run/openshift-sdn
  130. name: host-var-run-openshift-sdn
  131. # CNI related mounts which we take over
  132. - mountPath: /host/opt/cni/bin
  133. name: host-opt-cni-bin
  134. - mountPath: /etc/cni/net.d
  135. name: host-etc-cni-netd
  136. - mountPath: /var/lib/cni/networks/openshift-sdn
  137. name: host-var-lib-cni-networks-openshift-sdn
  138. resources:
  139. requests:
  140. cpu: 100m
  141. memory: 200Mi
  142. env:
  143. - name: OPENSHIFT_DNS_DOMAIN
  144. value: cluster.local
  145. ports:
  146. - name: healthz
  147. containerPort: 10256
  148. # TODO: Temporarily disabled until we determine how to wait for clean default
  149. # config
  150. # livenessProbe:
  151. # initialDelaySeconds: 10
  152. # httpGet:
  153. # path: /healthz
  154. # port: 10256
  155. # scheme: HTTP
  156. lifecycle:
  157. volumes:
  158. # In bootstrap mode, the host config contains information not easily available
  159. # from other locations.
  160. - name: host-config
  161. hostPath:
  162. path: /etc/origin/node
  163. - name: host-sysconfig-node
  164. hostPath:
  165. path: /etc/sysconfig/origin-node
  166. - name: host-modules
  167. hostPath:
  168. path: /lib/modules
  169. # TODO: access to the docker socket should be replaced by CRI socket
  170. - name: host-var-run
  171. hostPath:
  172. path: /var/run
  173. - name: host-var-run-dbus
  174. hostPath:
  175. path: /var/run/dbus
  176. - name: host-var-run-ovs
  177. hostPath:
  178. path: /var/run/openvswitch
  179. - name: host-var-run-kubernetes
  180. hostPath:
  181. path: /var/run/kubernetes
  182. - name: host-var-run-openshift-sdn
  183. hostPath:
  184. path: /var/run/openshift-sdn
  185. - name: host-opt-cni-bin
  186. hostPath:
  187. path: /opt/cni/bin
  188. - name: host-etc-cni-netd
  189. hostPath:
  190. path: /etc/cni/net.d
  191. - name: host-var-lib-cni-networks-openshift-sdn
  192. hostPath:
  193. path: /var/lib/cni/networks/openshift-sdn